# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_armdeployment`](#dsc_armdeployment): The DSC ARMDeployment resource type. Automatically generated from version 1.8.1
* [`dsc_poshfile`](#dsc_poshfile): The DSC POSHFile resource type. Automatically generated from version 1.8.1
* [`dsc_poshfolder`](#dsc_poshfolder): The DSC POSHFolder resource type. Automatically generated from version 1.8.1

## Resource types

### <a name="dsc_armdeployment"></a>`dsc_armdeployment`

The DSC ARMDeployment resource type.
Automatically generated from version 1.8.1

#### Properties

The following properties are available in the `dsc_armdeployment` type.

##### `dsc_deploymenttype`

Data type: `Optional[Enum['Incremental', 'Complete']]`

ARM deployment type

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

Ensure that the ARM deployment matches

##### `dsc_resourcegroup`

Data type: `String`

Resource group to deploy ARM template to

##### `dsc_resources`

Data type: `String`

JSON string of resources to deploy

##### `dsc_variables`

Data type: `Optional[String]`

JSON string of variables to use in deployment

##### `dsc_version`

Data type: `String`

Version of the ARM template

#### Parameters

The following parameters are available in the `dsc_armdeployment` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to connect to Azure Resource Manager

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the ARM deployment

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_poshfile"></a>`dsc_poshfile`

The DSC POSHFile resource type.
Automatically generated from version 1.8.1

#### Properties

The following properties are available in the `dsc_poshfile` type.

##### `dsc_contents`

Data type: `Optional[String]`

 

##### `dsc_contentsmatch`

Data type: `Optional[Boolean]`

 

##### `dsc_currentcontents`

Data type: `Optional[String]`

 

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

 

##### `dsc_exists`

Data type: `Optional[Boolean]`

 

##### `dsc_fullpath`

Data type: `Optional[String]`

 

##### `dsc_path`

Data type: `String`

 

#### Parameters

The following parameters are available in the `dsc_poshfile` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_poshfolder"></a>`dsc_poshfolder`

The DSC POSHFolder resource type.
Automatically generated from version 1.8.1

#### Properties

The following properties are available in the `dsc_poshfolder` type.

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

 

##### `dsc_exists`

Data type: `Optional[Boolean]`

 

##### `dsc_fullpath`

Data type: `Optional[String]`

 

##### `dsc_path`

Data type: `String`

 

#### Parameters

The following parameters are available in the `dsc_poshfolder` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

